<?php // Include only
if (!defined ('BOOT')) exit ('No bootstrap.  Exiting.');

/*
Wacintaki Poteto User Authorization Script Copyright 2005-2011 Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 1.5.8 - Last modified 7/17/2011

Requires:
	Preset $OekakiID and $OekakiPass if they are not cookies.
	$OekakiU still supported as alternate to $OekakiID

Control variables:
	$no_template, $no_online, $quiet_mode

Note:  Do not print anything in $quiet_mode unless it's a security problem, or else applets will freak out.  Just flush everything or use w_log().
*/


// Control variables
{
	// TRUE to avoid including/building template
	if (!isset ($no_template))
		$no_template = FALSE;

	// TRUE to disable online check
	if (!isset ($no_online))
		$no_online = FALSE;

	// TRUE to disable output (satisfies paint applets)
	if (!isset ($quiet_mode))
		$quiet_mode = FALSE;
}


// HTML DOCTYPE and HEAD reference
// Defined here (and not common.php), so test changes are tied to version number
function send_html_headers($override = '') {
	global $charset, $metatag_language;

	if (!empty ($charset)) {
		header ("Content-Type: text/html; charset={$charset}");
	}
	if (!empty ($metatag_language)) {
		header ("Content-Language: {$metatag_language}");
	}

	if ($override == 'html') {
	?>
<!DOCTYPE html PUBLIC
	"-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<?php
	} else {
	?>
<!DOCTYPE html PUBLIC
	"-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<?php
	}
}


function html_quick() {
	global $charset, $metatag_language;
	send_html_headers();

echo <<<EOF
<head>
	<meta http-equiv="Content-Type" content="text/html; charset={$charset}" />
	<meta http-equiv="Content-Language" content="{$metatag_language}" />
	<title>Wacintaki</title>
</head>

<body>

EOF;
}


function html_exit($text) {
	html_quick();
	echo '<div>'.$text.'</div>';
	echo "\n</body>\n</html>";
	w_exit();
}


function build_lang_names_cache() {
	$lang_names = array();
	if ($handle = opendir ('language')) {
		while (false !== ($file = readdir ($handle))) {
			$name = substr ($file, 0, -4);
			if (substr ($file, -4) == '.php' && $file != 'index.php') {
				$lang_names[] = $name;
			}
		}
		closedir ($handle);
	}
	sort ($lang_names);

	$lang_name_cache = array();
	$lang_http_accept_cache = array();
	foreach ($lang_names as $name) {
		@include ('language/'.$name.'.php');

		// 'german' => 'Deutsch / German'
		if ($name == 'english') {
			$lang_name_cache[$name] = $lang['cfg_language'];
		} else {
			$lang_name_cache[$name] = $lang['cfg_language'].' / '.$lang['cfg_lang_eng'];
		}

		// 'de' => 'german'
		$metatag_language = strtolower ($metatag_language);
		$lang_http_accept_cache[$metatag_language] = $name;

		unset ($lang);
	}

	$GLOBALS['lang']['names'] = $lang_name_cache;
	$GLOBALS['lang']['http_accept'] = $lang_http_accept_cache;

	if (!set_cache ('lang_names', $lang_name_cache, CACHE_EXPIRE_NEVER)) {
		return FALSE;
	}
	if (!set_cache ('lang_http_accept', $lang_http_accept_cache, CACHE_EXPIRE_NEVER)) {
		return FALSE;
	}

	return TRUE;
}


// ===================================================================
// Includes
//
$debug            = FALSE;
$wactest          = FALSE;
$maintenance_boot = FALSE;
$version             = '1.5.8'; // Format: M.m.r
$cfg_db_tables_check = '1.5.6'; // Version marker in database tables

// PHP Version
if (!defined ('PHP_VERSION_ID')) {
	$my_version = explode ('.', PHP_VERSION);
	define ('PHP_VERSION_ID', ($my_version[0] * 10000 + $my_version[1] * 100 + $my_version[2]));
}

// Autoglobal clean
$usrflags = NULL;
$row      = array();
$cookie_path   = '';
$cookie_domain = '';
$header_extra_metatags = ''; // Mostly for applet <script> tags
$mb_blink_o = '';
$mb_blink_c = '';
$vp_blink_o = '';
$vp_blink_c = '';
$stupid_name  = '';
$stupid_guest = '';

// Dates.  Now in language file.
$datef = array();
$datef['post_header'] = 'l, F jS Y, g:i A';
$datef['admin_edit']  = 'F j, Y, g:i a';
$datef['chat']        = 'H:i';
$datef['birthdate']   = 'Y/n/j';
$datef['birthmonth']  = 'Y/n';
$datef['birthyear']   = 'Y';


// Get config
$cfg = array();
if (!@include ('config.php')) {
	$maintenance_boot = TRUE;
} else {
	// ===================================================================
	// Hacks! (requires config, call before startup/common.php)
	// Included here since boot.php is used on EVERY page, and hacks may be security/user related
	//
	if (file_exists ($cfg['res_path'].'/'.'hacks.php')) {
		define ('HACK_CHECK', 1); // Version control
		include ($cfg['res_path'].'/'.'hacks.php');
	}
}


// Get database
{
	$dbconn             = FALSE;
	$db_version_check   = FALSE;
	$maintenance_update = FALSE;

	if (!file_exists ('dbconn.php')) {
		exit ("<html>\n<body>\n<p>Welcome to Wacintaki Poteto!</p>\n<p><a href=\"install.php\">Click here to run the installer</a>.</p>\n</body>\n</html>");
	} else {
		require ('db_layer.php');
	}

	$dbconn = db_open (TRUE);
	if (!$dbconn) {
		$maintenance_boot = TRUE;
	} else {
		$result  = db_query ("SELECT miscstring FROM {$db_p}oekakimisc WHERE miscname='dbversion'");
		$db_version_check = db_result ($result);
	}

	// Test for update
	if ($db_version_check != $cfg_db_tables_check) {
		$maintenance_boot   = TRUE;
		$maintenance_update = TRUE;
	}
}


// In 1.5.6, $maintenance_mode was renamed to $maintenance_boot
if (isset ($maintenance_mode) && $maintenance_mode) {
	$maintenance_boot = TRUE;
}

// Easy fixes
if (!defined ('MIN_AGE_ADULT')) {
	define ('MIN_AGE_ADULT', 18);
}
if (!defined ('ACTIVE_LOGIN_TIME_DAYS')) {
	define ('ACTIVE_LOGIN_TIME_DAYS', 180);
}


// Lightbox/Litebox/Lytebox/Slimbox
$pic_viewer_norm  = 'rel="lytebox[norm]"';
$pic_viewer_adult = 'rel="lytebox[adult]"';


// ===================================================================
// Startup
//

// E_ALL still needs some more testing, and can cause date() errors
// on servers without locale or timezones set correctly.
if (isset ($wactest) && $wactest) {
	//error_reporting (E_ALL);
	error_reporting (E_ALL | E_STRICT);
} else {
	error_reporting (E_ALL ^ E_NOTICE);
}

// Critical functions
require ('common.php');


// ===================================================================
// GPC
//

// Main
$mode    = w_gpc('mode', 'a');
$action  = w_gpc('action', 'a');
$pageno  = w_gpc('pageno', 'i+');
$sort    = w_gpc('sort', 'i+');
$artist  = w_gpc('artist');
$a_match = w_gpc('a_match');
$t_match = w_gpc('t_match');


// Login validation
// If not set elsewhere (ex: by applets), we import cookies here
if (!isset ($OekakiID)) {
	$OekakiID = '';
	if (isset ($_COOKIE['OekakiID'])) {
		$OekakiID = $_COOKIE['OekakiID'];
	}
}
if (!isset ($OekakiPass)) {
	$OekakiPass = '';
	if (isset ($_COOKIE['OekakiPass'])) {
		$OekakiPass = $_COOKIE['OekakiPass'];
	}
}

$OekakiID   = w_toalpha ($OekakiID);
$OekakiPass = addslashes (str_replace ('\\', '', $OekakiPass));

// Obsolete.  Set later while parsing $user
$OekakiU = '';


// ===================================================================
// Init
//

// Benchmark
$start_time = get_microtime();

// Cookies
$cookie_life = 2419200; // in seconds

// User info
$user  = array(); // SQL user data
$user['no_viewer'] = 0; // Another hack

$flags = array(); // Permission flags
$flags['all']    = $usrflags;
$flags['member'] = 0; // Is a registered member
$flags['G']      = 0; // Is a registered member (old flag)
$flags['mod']    = 0; // Is a moderator
$flags['admin']  = 0; // Is an admin
$flags['sadmin'] = 0; // Is a super admin
$flags['owner']  = 0; // Is owner
$flags['rank']   = 0; // (0-9)
$flags['D']      = 0; // Draw access
$flags['M']      = 0; // Anim access
$flags['I']      = 0; // Immunity
$flags['U']      = 0; // Upload access
$flags['X']      = 0; // Adult access

// Admin rank numbers
define ('RANK_MOD',    4);
define ('RANK_ADMIN',  5);
define ('RANK_SADMIN', 7);
define ('RANK_OWNER',  9);

// Cache control
//
// NOTE: we can't rely on the database to provide signed ints, so "forever"
// dates should be reasonably in the future.  Do NOT use the cache for long-
// term storage, so anything more than a few years is not reasonable.
define ('CACHE_EXPIRE',       864000);    // 15 days (default)
define ('CACHE_EXPIRE_LONG',  15768000);  // 6 months
define ('CACHE_EXPIRE_NEVER', 157680000); // Ought to be enough for anybody
define ('CACHE_EXPIRE_NOW',   0);

// Import init (needs config, hacks)
$language = $cfg['language'];
$template = $cfg['template'];
$cssinclude    = ''; // Path for HTML style tag
$template_name = '';

// Picture and thumbnail logic
$p_pic = $cfg['op_pics'].'/'.$cfg['op_pre'];
$t_pic = $cfg['op_pics'].'/'.$cfg['op_pre'].'t';
$r_pic = $cfg['op_pics'].'/'.$cfg['op_pre'].'r';
$p_prefix = $cfg['op_pre'];
$t_prefix = $cfg['op_pre'].'t';
$r_prefix = $cfg['op_pre'].'r';

// Mailbox
$mail_status = array();
$mail_status['new']     = 0;
$mail_status['unread']  = 1;
$mail_status['read']    = 2;
$mail_status['replied'] = 3;

// Drop-down menu in registration / edit profile.  Now in language file.
// "Y" and "M" and "D" in any order.  All 3 letters required.
$datef['age_menu'] = 'MDY';


// ===================================================================
// Maintenance login (before processing registration)
//
if ($maintenance_boot && $dbconn && isset($cfg['salt']) && w_gpc ('action') == 'login') {
	$username  = w_gpc('username');
	$pass      = w_gpc('pass');
	$usrpass3  = crypt ($pass, $cfg['salt']);
	$p_utf_fix = crypt (utf8_decode ($pass), $cfg['salt']);

	$result = db_query ("SELECT ID, usrname, usrpass, usrflags FROM {$db_mem}oekaki WHERE usrname='$username' AND rank=".RANK_OWNER);

	if ($result) {
		include ('language/'.$language.'.php');

		if (db_num_rows ($result) < 1) {
			html_exit ('<p>'.t('testvar1')."</p>\n");
		}

		$row = db_fetch_array ($result);

		// LEGACY (2011-03-27): Check for Latin-1 password
		if ($maintenance_update && $p_utf_fix == $row['usrpass']) {
			html_exit ('<p>'
				.t('please_update', 'update.php')."</p>\n<p>"
				.t('please_update_cur', $db_version_check)."</p>\n<p>"
				.t('please_update_new', $cfg_db_tables_check)."</p>\n"
			);
		}

		if ($usrpass3 == $row['usrpass']) {
			w_set_cookie ('OekakiID', $row['ID']);
			w_set_cookie ('OekakiPass', $usrpass3);

			// IIS-safe redirect
			all_done('index.php;in');
		} else {
			html_exit ('<p>'.t('testvar1')."</p>\n");
		}
	} else {
		html_exit ('<p>'.t('db_err')."</p>\n");
	}
}


// ===================================================================
// Process Registration
//
if ($dbconn && !empty ($OekakiPass) && (!empty ($OekakiU) || !empty ($OekakiID)) ) {
	if (!empty ($OekakiID)) {
		$result = db_query ("SELECT * FROM {$db_mem}oekaki WHERE ID='$OekakiID'");
	} else {
		// Todo: Legacy
		$result = db_query ("SELECT * FROM {$db_mem}oekaki WHERE usrname='$OekakiU'");
	}

	if (!$result) {
		// It's serious to have SQL bomb here
		w_log_sql('boot:'.__LINE__);

		if (!$quiet_mode) {
			// Not quiet mode?  DIE!
			header('Content-type: text/plain');
			w_exit ('Login failed due to a server error.  If the problem persists, ask the admin to check the oekaki log.');
		}
	}

	if (db_num_rows ($result)) {
		$user = db_fetch_array ($result);

		// Verify password
		if ($OekakiPass == $user['usrpass']) {
			// Verify active (non-pending)
			if (strstr ($user['usrflags'], 'G') && !strstr ($user['usrflags'], 'P')) {
				// Note: pending members should not have cookies!
				$flags['member'] = 1;
			}
		}
	}


	// If SQL works and registration checks out
	if ($flags['member'] == 1) {
		$OekakiID = $user['ID'];
		$OekakiU  = $user['usrname'];

		// Get flags ($usrflags, $rank)
		$flags = parse_flags($user['usrflags'], $user['rank']);

		//
		// Get language, template
		// Blank for either means use default
		//
		if (!empty ($user['language'])) {
			$language = $user['language'];
		}
		if (!empty ($user['templatesel'])) {
			$template = $user['templatesel'];
		}

		//
		// Update last login
		//
		if (!$maintenance_boot) {
			$result = db_query ("UPDATE {$db_mem}oekaki SET lastlogin=NOW() WHERE usrname='$OekakiU'");
		}
	} else {
		// Nuke 'em

		$OekakiID = '';
		$OekakiU  = '';
		$OekakiPass = '';
		$user = array();

		if (!$quiet_mode) {
			if ($debug) {
				echo 'Cookie Reset';
			} else {
				w_unset_cookie('OekakiID');
				w_unset_cookie('OekakiPass');

				// Todo: Legacy
				if (isset ($_COOKIE['OekakiU'])) {
					w_unset_cookie('OekakiU');
				}
			}
		}
	}
}


// ===================================================================
// Language
//
// Get cache; rebuild if needed
$lang['names'] = get_cache ('lang_names');
if (empty ($lang['names'])) {
	build_lang_names_cache();
} else {
	// Check for language file update
	if ($flags['owner'] || isset ($_REQUEST['guest_lang']) ) {
		// In liu of a modular language/template system where packages have to be
		// installed, we'll check the cache every time the owner logs in or
		// the language is explicitly selected via the guest menu.
		$result5 = db_query ("SELECT built FROM {$db_p}oekakicache WHERE name='lang_names'");

		if (filemtime ('language/'.$language.'.php') > db_result ($result5)) {
			// File updated.  Rebuild cache.
			build_lang_names_cache();
		}
	} else {
		$lang['http_accept'] = get_cache ('lang_http_accept');
	}
}
if (empty ($lang['http_accept'])) {
	build_lang_names_cache();
}

// Check for guest language
if (!defined ('DISABLE_GUEST_LANG') || !DISABLE_GUEST_LANG) {
	$guest_lang = trim (w_gpc('guest_lang')); // $_GET
	$OekakiLang = trim (w_gpc('OekakiLang')); // $_COOKIE
	if (empty ($OekakiU)) {
		if (!empty ($guest_lang)) {
			// Caution: filter input
			if (!badChars ($guest_lang, 'file')) {
				if ($guest_lang != $OekakiLang) {
					// Set new language
					w_set_cookie('OekakiLang', $guest_lang);
					$OekakiLang = $guest_lang;
				}
				$language = $guest_lang;
			}
		}

		if (!empty ($OekakiLang)) {
			if (!badChars ($OekakiLang, 'file')) {
				if (file_exists ('language/'.$OekakiLang.'.php')) {
					$language = $OekakiLang;
				}
			}
		} else {
			$temp = get_http_accept_lang();
			// $language = $cfg['language'];

			// Rough match
			foreach ($lang['http_accept'] as $accept => $serve) {
				$base = $accept;
				if (strpos ($accept, '-') !== FALSE) {
					list ($base, $dialect) = explode ('-', $accept);
				}
				if (strpos ($temp, $base) !== FALSE) {
					$language = $serve;
				}
			}

			// Exact/better match
			foreach ($lang['http_accept'] as $accept => $serve) {
				if ($accept == $temp) {
					$language = $serve;
				}
			}
		}
	}
}

// Needed in quiet mode for error reporting
if ($language != 'english' && file_exists ('language/'.$language.'.php')) {
	include ('language/'.$language.'.php');
} else {
	include ('language/english.php');
}

// Verify language $datef['age_menu'] has all 3 letters
if (
	strlen ($datef['age_menu']) != 3
	|| strpos ($datef['age_menu'], 'Y') === FALSE
	|| strpos ($datef['age_menu'], 'M') === FALSE
	|| strpos ($datef['age_menu'], 'D') === FALSE
	)
{
	$datef['age_menu'] = 'MDY';
}


// ===================================================================
// Maintenance mode ($maintenance_boot)
//
if ($maintenance_boot) {
	if (!$dbconn) {
		html_exit ('<p>'.db_error()."</p>\n");
	}

	// Check for owner login
	if (!$flags['owner']) {
		$my_email = '<a href="mailto:'.$cfg['op_email'].'">'.email_code($cfg['op_email']).'</a>';

		html_quick();

		echo ("\n<h2>".t('boot_down_maint')."</h2>\n");
		echo ('<p>'.t('boot_maint_exp', $cfg['op_title'], $my_email)."</p>\n");

?>

<h2><?php tt('header_diag'); ?></h2>
<div id="adminbar">
	<form name="form_login_boot" action="index.php" method="post">
		<input name="action" type="hidden" value="login" />

		<?php tt('word_name');?> 
		<input name="username" type="text" class="multiline" />

		<?php tt('install_password');?> 
		<input name="pass" type="password" class="multiline" />
		<input name="login" type="submit" value="<?php tt('install_login');?>" class="submit" />
	</form>
</div>
<?php

		w_exit("\n</body>\n</html>");
	}

	// Update magic
	if ($maintenance_update) {
		html_exit ('<p>'
			.t('please_update', 'update.php')."</p>\n<p>"
			.t('please_update_cur', $db_version_check)."</p>\n<p>"
			.t('please_update_new', $cfg_db_tables_check)."</p>\n"
		);
	}

	// Uncaught condition.  Check for broken stuff.
	if (!isset ($cfg['version'])) {
		html_exit ('<p>'.t('err_wrconfig')."</p>\n");
	}
}


// ===================================================================
// Ban list
// BAN_OVERRIDE is for hacks, BAN_KILL is internal use only
//
// Get IP and hostname
$address  = 'invalid';
$hostname = '';
if (!empty ($_SERVER['REMOTE_ADDR'])) {
	$address = $_SERVER['REMOTE_ADDR'];
	if (defined ('ENABLE_DNS_HOST_LOOKUP') && ENABLE_DNS_HOST_LOOKUP) {
		$hostname = @gethostbyaddr ($address);
	} else {
		$hostname = '';
	}
}

if (! (defined ('BAN_OVERRIDE') && BAN_OVERRIDE)) {
	if (! (defined ('BAN_KILL') && BAN_KILL)) {
		// !hacks.php
		require ('banscript.php');
	}
}

// Track IP after loading ban list
if (!empty ($OekakiU) && !empty ($OekakiPass)) {
	$result = db_query ("UPDATE `{$db_mem}oekaki` SET `IP`='{$address}' WHERE `usrname`='$OekakiU'");
}


// ===================================================================
// Template
//
if (!$quiet_mode) {

	// Import niftytoo
	require ('niftytoo.php');

	// Build and set template
	//
	$template_name = $template;
	$template_file = $cfg['tpl_path'].'/'.$template;
	$cssinclude = $template_file.'.css';

	if (!$no_template) {
		// If regular member, use built CSS
		// If admin, compare template w/CSS and rebuild if needed

		$my_css_exists = FALSE;
		$my_template_build = FALSE;

		if (file_exists ($template_file.'.css')) {
			$my_css_exists = TRUE;
		}

		if ($my_css_exists) {
			if ($flags['admin']) {
				if (file_exists ($template_file.'.php')) {
					if (filemtime ($template_file.'.php') > filemtime ($template_file.'.css')) {
						// Template is newer!  Rebuild CSS.
						$my_template_build = TRUE;
					}
				}
			}
		} else {
			// No CSS.  New template?
			$my_template_build = TRUE;
		}

		if ($my_template_build) {
			if (file_exists ($template_file.'.php')) {
				if (!is_writable ($cfg['tpl_path'])) {
					html_exit( t('boot_folder_locked', 'Templates', 'Readme.txt') );
				}

				// Build CSS
				$tcontrol = 'build';
				ob_start();
				include ($template_file.'.php');
				$cssdata = ob_get_contents();
				if (!empty ($cssdata) && $handle = @fopen ($template_file.'.css', 'w')) {
					fwrite ($handle, $cssdata);
					fclose ($handle);
				} else {
					// CSS problem! Use default
					$cssinclude = $cfg['tpl_path'].'/'.$template.'.css';
					$template_name = $template;

					if (!file_exists($cssinclude)) {
						// Mega problem!
						$cssinclude = $cfg['tpl_path'].'/Default.css';
						$template_name = 'Failsafe';
					}
				}
				ob_clean();
				unset ($tcontrol);
			} else {
				/*
				Let's hope that a broken template returns a 404, so admins will
				look for what's wrong.  Don't throw w_exit(), so admins can still
				actually moderate if the template is b0rked!
				*/
			}
		}
	} // End template build


	// Set layout, thumbnail
	if ($flags['member']) {
		$display = $user['picview'];
		$screensize = 800;
		if ($user['screensize'] > 0) {
			$screensize = $user['screensize'];
		}

		if ($cfg['force_thumb'] == 'yes' || $user['thumbview'] == 0) {
			$thumbDisplay = $cfg['use_thumb'];
		} else {
			$thumbDisplay = $user['thumbview'];
		}

		// Account "Screenshot" disables thumbnails
		if (strtolower ($OekakiU) == 'screenshot') {
			$thumbDisplay = 0;
		}
	} else {
		$display = 0;
		$screensize = 800;
		$thumbDisplay = $cfg['use_thumb'];
	}
} // End quiet mode


// ===================================================================
// Secure installer/updater
//
if (!$quiet_mode) {
	// Check installer, updater.  For effiency and to resolve conflicts
	// with non-installed boards, check for admin cookies only.

	if ($action == 'secure') {
		html_quick();

		$my_fail = 0;
		if (file_exists('install.php')) {
			if (@unlink('install.php')) {
				echo t('boot_inst_rm')."<br />\n";
			} else {
				echo t('boot_inst_rm_fail')."<br />\n";
				$my_fail++;
			}
		}
		if (file_exists('update.php')) {
			if (file_exists('update_rc.php')) {
				@unlink ('update_rc.php');
			}
			if (@unlink ('update.php')) {
				echo t('boot_update_rm')."<br />\n";
			} else {
				echo t('boot_update_rm_fail')."<br />\n";
				$my_fail++;
			}
		}
		if ($my_fail) {
			echo '<p>'.t('boot_remove_ftp').'</p>';
		} else {
			echo '<p><a href="index.php">'.t('boot_goto_index').'</a></p>';
		}
		w_exit("</body>\n</html>");
	}
	if ($flags['admin']) {
		if (file_exists ('install.php') || file_exists ('update.php')) {
			html_exit (
				'<p>'
				.t('boot_still_exist_sub1')."</p>\n<p>"
				.t('boot_still_exist_sub2', 'index.php?action=secure')."</p>\n<p>"
				.t('boot_still_exist_sub3')."</p>"
			);
		}
	}
} // End quiet mode


// ===================================================================
// Online list
//
if (!$quiet_mode) {
	// One of the few times the $lang var is used directly
	// Useful for debugging, so almost all scripts are included

	if (!$no_online) {
		if (!empty ($_SERVER['PHP_SELF'])) {
			// Fixes servers using PHP as a runtime and not as a module
			$my_script = $_SERVER['PHP_SELF'];
		} else {
			$my_script = $SCRIPT_NAME;
		}
		$my_script = strtolower (basename ($my_script));


		$loc = 'unknown';
		if ($my_pos = strrpos ($my_script, '.')) {
			// Strip extension
			$loc = w_toalpha( substr( $my_script, 0, $my_pos));
		}

		// Fix special cases
		if (substr ($loc, 0, 4) == 'mail') {
			$loc = 'mail';
		}
		if (substr ($loc, 0, 4) == 'chat') {
			$loc = 'chatbox';
		}
		if (isset ($_REQUEST['a_match']) || isset($_REQUEST['artist'])) {
			$loc = 'index_match';
		}


		// Maintenance (avoid on scripts that auto-refresh)
		if ($loc != 'chat' && $loc != 'online') {
			$online = db_query ('DELETE FROM '.$db_mem.'oekakionline WHERE (DATE_ADD(onlinetime, INTERVAL 15 MINUTE) < NOW())');

			$online = db_query ('DELETE FROM '.$db_mem.'oekakionline WHERE (DATE_ADD(onlinetime, INTERVAL 1 MINUTE) < NOW()) AND locale=\'chat\'');
		}

		if ($flags['member'] && !empty ($OekakiU) && $loc != 'whosonline' && $loc != 'error') {
			$result = db_query ("SELECT onlineusr FROM {$db_mem}oekakionline WHERE onlineusr='{$OekakiU}'");

			if (db_num_rows($result)) {
				$online = db_query ("UPDATE {$db_mem}oekakionline SET onlinetime=NOW(), locale='o_{$loc}', onlineboard='".addslashes ($cfg['op_title'])."' WHERE onlineusr='{$OekakiU}'");
			} else {
				$online = db_query ("INSERT INTO {$db_mem}oekakionline SET onlineusr='{$OekakiU}', onlinetime=NOW(), onlineIP='{$address}', locale='o_{$loc}', onlineboard='".addslashes ($cfg['op_title'])."'");
			}
		}
	}
} // End quiet mode



// Regular maintenance
// For now, we'll only run this during normal browsing, not on a scheduler
if (!$quiet_mode && empty ($mode) && empty ($action)) {
	require ('maint.php');
}

?>